image: node:14
stages:
  - build-and-test-merge-request
  - build-and-test-main

before_script:
  - npm i -g npm@7
  - npm install --pure-lockfile --cache-folder

build-and-test-main:
  stage: build-and-test-main
  interruptible: true
  only:
    - main
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules
  script:
    - npm run affected:lint
    - npm run affected:test
    - npm run affected:deploy-prod

build-and-test-merge-request:
  stage: build-and-test-merge-request
  interruptible: true
  only:
    refs:
      - merge_requests
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules
  script:
    - git fetch
    - npx nx affected run-many --base=origin/${CI_MERGE_REQUEST_TARGET_BRANCH_NAME} --target=lint
    - npx nx affected run-many --base=origin/${CI_MERGE_REQUEST_TARGET_BRANCH_NAME} --target=test
    - npx nx affected run-many --base=origin/${CI_MERGE_REQUEST_TARGET_BRANCH_NAME} --target=deploy-dev
